.\" $OpenBSD: upgt.4,v 1.20 2013/03/14 20:55:01 tedu Exp $
.\"
.\" Copyright (c) 2007 Marcus Glocker <mglocker@openbsd.org>
.\" Copyright (c) 2005-2007
.\"     Damien Bergamini <damien.bergamini@free.fr>
.\"
.\" Permission to use, copy, modify, and distribute this software for any
.\" purpose with or without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
.\" WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
.\" MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
.\" ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
.\" WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
.\" ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
.\" OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
.\"
.\"
.\"
.\" Copyright (c) 2006 Theo de Raadt.
.\" Copyright (c) 2006 The DragonFly Project.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\"
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in
.\"    the documentation and/or other materials provided with the
.\"    distribution.
.\" 3. Neither the name of The DragonFly Project nor the names of its
.\"    contributors may be used to endorse or promote products derived
.\"    from this software without specific, prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
.\" LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
.\" FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE
.\" COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES (INCLUDING,
.\" BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
.\" LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
.\" AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
.\" OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd $Mdocdate: March 14 2013 $
.Dt UPGT 4
.Os
.Sh NAME
.Nm upgt
.Nd Conexant/Intersil PrismGT SoftMAC USB IEEE 802.11b/g wireless network
device
.Sh SYNOPSIS
.Cd "upgt* at uhub? port ?"
.Sh DESCRIPTION
The
.Nm
driver supports the USB 2.0 Conexant/Intersil PrismGT series wireless
adapters based on the GW3887 chipset.
.Pp
These are the modes the
.Nm
driver can operate in:
.Bl -tag -width "IBSS-masterXX"
.It BSS mode
Also known as
.Em infrastructure
mode, this is used when associating with an access point, through
which all traffic passes.
This mode is the default.
.It monitor mode
In this mode the driver is able to receive packets without
associating with an access point.
This disables the internal receive filter and enables the card to
capture packets from networks which it wouldn't normally have access to,
or to scan for access points.
.El
.Pp
The
.Nm
driver can be configured to use
Wired Equivalent Privacy (WEP) or
Wi-Fi Protected Access (WPA-PSK and WPA2-PSK).
WPA is the de facto encryption standard for wireless networks.
It is strongly recommended that WEP
not be used as the sole mechanism
to secure wireless communication,
due to serious weaknesses in it.
The
.Nm
driver relies on the software 802.11 stack for both encryption and decryption
of data frames.
.Pp
The
.Nm
driver can be configured at runtime with
.Xr ifconfig 8
or on boot with
.Xr hostname.if 5 .
.Sh FILES
The driver needs a firmware file which is loaded when an interface is
brought up:
.Pp
.Bl -tag -width Ds -offset indent -compact
.It Pa /etc/firmware/upgt-gw3887
.El
.\".Pp
.\"These firmware files are not free because Conexant/Intersil refuses
.\"to grant distribution rights.
.\"As a result, even though
.\".Ox
.\"includes the driver, the firmware files cannot be included and
.\"users have to download these files on their own.
.Pp
A prepackaged version of the firmware can be installed using
.Xr fw_update 1 .
.Sh HARDWARE
The following adapters should work:
.Pp
.Bl -tag -width Ds -offset indent -compact
.It Belkin F5D7050 (version 1000)
.It Cohiba Proto Board
.It D-Link DWL-G120 Cohiba
.It D-Link DWL-G122 rev A2
.It FSC Connect2Air E-5400 USB D1700
.It Gigaset USB Adapter 54
.It Inventel UR045G
.It IOGear GWU513
.It Linksys WUSB54AG
.It Linksys WUSB54G ver 2
.It Medion MD40900
.It Philips CPWUA054
.It SMC EZ ConnectG SMC2862W-G
.It Sagem XG703A
.It Spinnaker DUT
.It Spinnaker Proto Board
.It Thomson SpeedTouch 121g
.El
.Sh EXAMPLES
The following example scans for available networks:
.Pp
.Dl # ifconfig upgt0 scan
.Pp
The following
.Xr hostname.if 5
example configures upgt0 to join network
.Dq mynwid ,
using WPA key
.Dq mywpakey ,
obtaining an IP address using DHCP:
.Bd -literal -offset indent
nwid mynwid
wpakey mywpakey
dhcp
.Ed
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr intro 4 ,
.Xr netintro 4 ,
.Xr usb 4 ,
.Xr hostname.if 5 ,
.\".Xr hostapd 8 ,
.Xr ifconfig 8
.Sh HISTORY
The
.Nm
driver first appeared in
.Ox 4.3 .
.Sh AUTHORS
.An -nosplit
The
.Nm
driver was written by
.An Marcus Glocker Aq mglocker@openbsd.org .
.Pp
The hardware specification was reverse engineered by the people at
.Lk http://www.prism54.org .
.Sh CAVEATS
The
.Nm
driver just supports the USB 2.0 devices (GW3887 chipset) but not the
USB 1.0 devices containing the NET2280, ISL3880, and ISL3886 chipsets.
Some further efforts would be necessary to add USB 1.0 support to the
driver.
